export declare var Schemas: any;
export declare namespace Energistics {
    namespace Datatypes {
        class ArrayOfBoolean {
            values: Array<boolean>;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class ArrayOfDouble {
            values: Array<number>;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class ArrayOfFloat {
            values: Array<number>;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class ArrayOfLong {
            values: Array<number>;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class ArrayOfInt {
            values: Array<number>;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class AnyArray {
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class Contact {
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class DataValue {
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class DataAttribute {
            attributeId: number;
            attributeValue: Energistics.Datatypes.DataValue;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class MessageHeader {
            protocol: number;
            messageType: number;
            correlationId: number;
            messageId: number;
            messageFlags: number;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        enum Protocols {
            Core = 0,
            ChannelStreaming = 1,
            ChannelDataFrame = 2,
            Discovery = 3,
            Store = 4,
            StoreNotification = 5,
            GrowingObject = 6,
            DataArray = 7,
            WitsmlSoap = 8,
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class Version {
            major: number;
            minor: number;
            revision: number;
            patch: number;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class SupportedProtocol {
            protocol: number;
            protocolVersion: Energistics.Datatypes.Version;
            role: string;
            protocolCapabilities: any;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        class ServerCapabilities {
            applicationName: string;
            applicationVersion: string;
            supportedProtocols: Array<Energistics.Datatypes.SupportedProtocol>;
            supportedObjects: Array<string>;
            contactInformation: Energistics.Datatypes.Contact;
            supportedEncodings: string;
            static _schema: any;
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            enum ChannelIndexTypes {
                Time = 0,
                Depth = 1,
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            enum ChannelStatuses {
                Active = 0,
                Inactive = 1,
                Closed = 2,
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class ChannelRangeInfo {
                channelId: Array<number>;
                startIndex: number;
                endIndex: number;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class DataFrame {
                index: Array<number>;
                data: Array<Energistics.Datatypes.DataValue>;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class DataItem {
                indexes: Array<number>;
                channelId: number;
                value: Energistics.Datatypes.DataValue;
                valueAttributes: Array<Energistics.Datatypes.DataAttribute>;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            enum Roles {
                producer = 0,
                consumer = 1,
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            enum IndexDirections {
                Increasing = 0,
                Decreasing = 1,
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class IndexMetadataRecord {
                indexType: Energistics.Datatypes.ChannelData.ChannelIndexTypes;
                uom: string;
                direction: Energistics.Datatypes.ChannelData.IndexDirections;
                customData: any;
                scale: number;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class StreamingStartIndex {
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class ChannelStreamingInfo {
                channelId: number;
                startIndex: Energistics.Datatypes.ChannelData.StreamingStartIndex;
                receiveChangeNotification: boolean;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace Object {
            class GrowingObjectIndex {
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace Object {
            class NotificationRequestRecord {
                uri: string;
                uuid: string;
                includeObjectData: boolean;
                startTime: number;
                objectTypes: Array<string>;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace Object {
            enum ObjectChangeTypes {
                Upsert = 0,
                Delete = 1,
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace Object {
            class Resource {
                uri: string;
                contentType: string;
                name: string;
                channelSubscribable: boolean;
                customData: any;
                resourceType: string;
                hasChildren: number;
                lastChanged: number;
                objectNotifiable: boolean;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace Object {
            class DataObject {
                resource: Energistics.Datatypes.Object.Resource;
                contentEncoding: string;
                data: string;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace ChannelData {
            class ChannelMetadataRecord {
                channelUri: string;
                channelId: number;
                indexes: Array<Energistics.Datatypes.ChannelData.IndexMetadataRecord>;
                channelName: string;
                dataType: string;
                uom: string;
                description: string;
                status: Energistics.Datatypes.ChannelData.ChannelStatuses;
                source: string;
                measureClass: string;
                customData: any;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Datatypes {
        namespace Object {
            class ObjectChange {
                changeType: Energistics.Datatypes.Object.ObjectChangeTypes;
                changeTime: number;
                dataObject: Energistics.Datatypes.Object.DataObject;
                static _schema: any;
            }
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelDataFrame {
            class ChannelDataFrameSet {
                channels: Array<number>;
                data: Array<Energistics.Datatypes.ChannelData.DataFrame>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelDataFrameSet: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelDataFrame {
            class ChannelMetadata {
                channels: Array<Energistics.Datatypes.ChannelData.ChannelMetadataRecord>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelMetadata: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelDataFrame {
            class RequestChannelData {
                uri: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgRequestChannelData: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelDataChange {
                channelId: number;
                startIndex: number;
                endIndex: number;
                data: Array<Energistics.Datatypes.ChannelData.DataItem>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelDataChange: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelData {
                data: Array<Energistics.Datatypes.ChannelData.DataItem>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelData: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelDescribe {
                uris: Array<string>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelDescribe: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelMetadata {
                channels: Array<Energistics.Datatypes.ChannelData.ChannelMetadataRecord>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelMetadata: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelRangeRequest {
                channelRanges: Array<Energistics.Datatypes.ChannelData.ChannelRangeInfo>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelRangeRequest: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelStreamingStart {
                channels: Array<Energistics.Datatypes.ChannelData.ChannelStreamingInfo>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelStreamingStart: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelRemove {
                channelId: number;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelRemove: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelStatusChange {
                channelId: number;
                status: Energistics.Datatypes.ChannelData.ChannelStatuses;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelStatusChange: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class Start {
                maxMessageRate: number;
                maxDataItems: number;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgStart: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace ChannelStreaming {
            class ChannelStreamingStop {
                channels: Array<number>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChannelStreamingStop: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Core {
            class Acknowledge {
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgAcknowledge: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Core {
            class CloseSession {
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgCloseSession: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Core {
            class OpenSession {
                applicationName: string;
                applicationVersion: string;
                sessionId: string;
                supportedProtocols: Array<Energistics.Datatypes.SupportedProtocol>;
                supportedObjects: Array<string>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgOpenSession: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Core {
            class ProtocolException {
                errorCode: number;
                errorMessage: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgProtocolException: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Core {
            class RenewSecurityToken {
                token: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgRenewSecurityToken: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Core {
            class RequestSession {
                applicationName: string;
                applicationVersion: string;
                requestedProtocols: Array<Energistics.Datatypes.SupportedProtocol>;
                supportedObjects: Array<string>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgRequestSession: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace DataArray {
            class DataArray {
                dimensions: Array<number>;
                data: Energistics.Datatypes.AnyArray;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgDataArray: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace DataArray {
            class GetDataArray {
                uri: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGetDataArray: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace DataArray {
            class PutDataArraySlice {
                uri: string;
                data: Energistics.Datatypes.AnyArray;
                dimensions: Array<number>;
                start: Array<number>;
                count: Array<number>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgPutDataArraySlice: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace DataArray {
            class PutDataArray {
                uri: string;
                data: Energistics.Datatypes.AnyArray;
                dimensions: Array<number>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgPutDataArray: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace DataArray {
            class GetDataArraySlice {
                uri: string;
                start: Array<number>;
                count: Array<number>;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGetDataArraySlice: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Discovery {
            class GetResourcesResponse {
                resource: Energistics.Datatypes.Object.Resource;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGetResourcesResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Discovery {
            class GetResources {
                uri: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGetResources: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace GrowingObject {
            class GrowingObjectDeleteRange {
                uri: string;
                startIndex: Energistics.Datatypes.Object.GrowingObjectIndex;
                endIndex: Energistics.Datatypes.Object.GrowingObjectIndex;
                uom: string;
                depthDatum: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGrowingObjectDeleteRange: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace GrowingObject {
            class GrowingObjectDelete {
                uri: string;
                uid: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGrowingObjectDelete: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace GrowingObject {
            class GrowingObjectGet {
                uri: string;
                uid: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGrowingObjectGet: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace GrowingObject {
            class GrowingObjectGetRange {
                uri: string;
                startIndex: Energistics.Datatypes.Object.GrowingObjectIndex;
                endIndex: Energistics.Datatypes.Object.GrowingObjectIndex;
                uom: string;
                depthDatum: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGrowingObjectGetRange: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace GrowingObject {
            class GrowingObjectPut {
                uri: string;
                contentType: string;
                contentEncoding: string;
                data: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGrowingObjectPut: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace GrowingObject {
            class ObjectFragment {
                uri: string;
                contentType: string;
                contentEncoding: string;
                data: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgObjectFragment: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Store {
            class DeleteObject {
                uri: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgDeleteObject: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Store {
            class GetObject {
                uri: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgGetObject: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Store {
            class PutObject {
                dataObject: Energistics.Datatypes.Object.DataObject;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgPutObject: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace Store {
            class Object {
                dataObject: Energistics.Datatypes.Object.DataObject;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgObject: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace StoreNotification {
            class ChangeNotification {
                change: Energistics.Datatypes.Object.ObjectChange;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgChangeNotification: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace StoreNotification {
            class DeleteNotification {
                delete: Energistics.Datatypes.Object.ObjectChange;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgDeleteNotification: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace StoreNotification {
            class CancelNotification {
                requestUuid: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgCancelNotification: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace StoreNotification {
            class NotificationRequest {
                request: Energistics.Datatypes.Object.NotificationRequestRecord;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgNotificationRequest: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_AddToStore {
                WMLtypeIn: string;
                XMLin: string;
                OptionsIn: string;
                CapabilitiesIn: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_AddToStore: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_DeleteFromStore {
                WMLtypeIn: string;
                XMLin: string;
                OptionsIn: string;
                CapabilitiesIn: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_DeleteFromStore: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_GetBaseMsg {
                ReturnValueIn: number;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_GetBaseMsg: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_GetCap {
                OptionsIn: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_GetCap: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_GetVersion {
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_GetVersion: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_GetFromStore {
                WMLtypeIn: string;
                XMLin: string;
                OptionsIn: string;
                CapabilitiesIn: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_GetFromStore: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMLS_UpdateInStore {
                WMLtypeIn: string;
                XMLin: string;
                OptionsIn: string;
                CapabilitiesIn: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMLS_UpdateInStore: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_AddToStoreResponse {
                Result: number;
                SuppMsgOut: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_AddToStoreResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_GetCapResponse {
                Result: number;
                CapabilitiesOut: string;
                SuppMsgOut: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_GetCapResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_DeleteFromStoreResponse {
                Result: number;
                SuppMsgOut: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_DeleteFromStoreResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_GetBaseMsgResponse {
                Result: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_GetBaseMsgResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_GetFromStoreResponse {
                Result: number;
                XMLout: string;
                SuppMsgOut: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_GetFromStoreResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_GetVersionResponse {
                Result: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_GetVersionResponse: number;
        }
    }
}
export declare namespace Energistics {
    namespace Protocol {
        namespace WitsmlSoap {
            class WMSL_UpdateInStoreResponse {
                Result: number;
                SuppMsgOut: string;
                static _schema: any;
                static _protocol: number;
                static _messageTypeId: number;
            }
            var MsgWMSL_UpdateInStoreResponse: number;
        }
    }
}
